--- old/usr/src/uts/i86pc/dboot/dboot_elfload.c	Fri Jan 17 08:41:10 2020
+++ new/usr/src/uts/i86pc/dboot/dboot_elfload.c	Fri Jan 17 08:41:10 2020
@@ -185,7 +185,7 @@
 		/* zero out bss */
 		if (shdr->sh_type == SHT_NOBITS) {
 			if (prom_debug)
-				dboot_printf("zeroing BSS %ld bytes from "
+				dboot_printf("zeroing BSS %lu bytes from "
 				    "physaddr 0x%" PRIx64
 				    " (end=0x%" PRIx64 ")\n",
 				    (ulong_t)shdr->sh_size,
--- old/usr/src/uts/i86pc/dboot/dboot_printf.c	Fri Jan 17 08:41:10 2020
+++ new/usr/src/uts/i86pc/dboot/dboot_printf.c	Fri Jan 17 08:41:10 2020
@@ -21,6 +21,7 @@
 
 /*
  * Copyright (c) 2012 Gary Mills
+ * Copyright 2020 Joyent, Inc.
  *
  * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
@@ -93,7 +94,7 @@
 }
 
 static void
-dboot_putnum(uint64_t x, uint_t is_signed, uint8_t base)
+dboot_putnum(uint64_t x, boolean_t is_signed, uint8_t base)
 {
 	char buffer[64];	/* digits in reverse order */
 	int i;
@@ -114,7 +115,7 @@
 }
 
 /*
- * very primitive printf - only does %s, %d, %x, %lx, or %%
+ * Very primitive printf - only does a subset of the standard format characters.
  */
 static void
 do_dboot_printf(char *fmt, va_list args)
@@ -123,7 +124,6 @@
 	uint64_t x;
 	uint8_t base;
 	uint8_t size;
-	uint_t is_signed = 1;
 
 	if (fmt == NULL) {
 		dboot_puts("dboot_printf(): 1st arg is NULL\n");
@@ -159,7 +159,7 @@
 
 		case 'p':
 			x = va_arg(args, ulong_t);
-			dboot_putnum(x, !is_signed, 16);
+			dboot_putnum(x, B_FALSE, 16);
 			break;
 
 		case 'l':
@@ -176,9 +176,13 @@
 				x = va_arg(args, long);
 			else
 				x = va_arg(args, long long);
-			dboot_putnum(x, is_signed, 10);
+			dboot_putnum(x, B_TRUE, 10);
 			break;
 
+		case 'u':
+			base = 10;
+			goto unsigned_num;
+
 		case 'b':
 			base = 2;
 			goto unsigned_num;
@@ -192,11 +196,11 @@
 unsigned_num:
 			if (size == 0)
 				x = va_arg(args, uint_t);
-			else if (size == sizeof (long))
+			else if (size == sizeof (ulong_t))
 				x = va_arg(args, ulong_t);
 			else
 				x = va_arg(args, unsigned long long);
-			dboot_putnum(x, !is_signed, base);
+			dboot_putnum(x, B_FALSE, base);
 			break;
 
 		default:
